//
//  SSMotionEffectSimple.m
//  TextInMotion
//
//  Trivial ME subclass that returns movements based on static factors and a notification
//
//  Created by Bertils mini on 2014-01-12.
//  Copyright (c) 2014 Sork Software. All rights reserved.
//

#import "SSMotionEffectSimple.h"
#import "SSViewController.h"

@implementation SSMotionEffectSimple

#pragma mark - UIMotionEffects Method

// SS modification with position and notification
- (NSDictionary *)keyPathsAndRelativeValuesForViewerOffset:(UIOffset)viewerOffset {
    // Apply a static factor to the movement offsets
    CGFloat xOffset = 11 * viewerOffset.horizontal;
    CGFloat yOffset = 11 * viewerOffset.vertical;
    
    // This method returns a value associated with property key paths
    NSValue *offsetPoint = [NSValue valueWithCGPoint:CGPointMake(xOffset, yOffset)];
    
    // Notify our VC about a move action and its offsets packed into a dictionary as a point value
    NSValue *offsets = [NSValue valueWithCGPoint:CGPointMake(viewerOffset.horizontal, viewerOffset.vertical)];
    NSDictionary *didMove = @{@"Move" : self, @"Offset" : offsets};
    [[NSNotificationCenter defaultCenter] postNotificationName:MoveNotification object:self userInfo:didMove];
    
    // The view property key path will be modified with the adjusted offsets
    return @{@"center" : offsetPoint};
}

@end
