//
//  SSViewController.m
//  TextInMotion
//
//  Created by Bertils mini on 2014-01-06.
//  Copyright (c) 2014 Sork Software. All rights reserved.
//

#import "SSViewController.h"
#import "TitleView.h"
#import "SSMotionEffectSimple.h"

NSString *MoveNotification = @"Text Moved";

@implementation SSViewController {
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Create our simplistic ME subclass thingy and add it to the titleView
    [self.titleView addMotionEffect:[[SSMotionEffectSimple alloc] init]];
    
    // Listen to notifications from the ME subclass and update the titleView
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(deviceMoved:)
												 name:MoveNotification object:nil];
}

#pragma mark - Notifications

// The user moved the device
- (void)deviceMoved:(NSNotification *)notification {
	// Get the move from the notifications userInfo
    NSValue *theMove = [[notification userInfo] objectForKey:@"Offset"];
    CGPoint thePoint = [theMove CGPointValue];
	
    //NSLog(@"VC received move with x %f and y %f", thePoint.x, thePoint.y);
    
    // Update the drawing with the new offsets
    self.titleView.offsets = thePoint;
    
    [self.titleView setNeedsDisplay];
}

@end
