//
//  TitleView.m
//  Putta
//
//  Draw the tokidoki title in hiragana characters with a shadow
//
//  Created by Bertils mini on 2012-10-14.
//
//

#import "TitleView.h"

@implementation TitleView

- (id)initWithCoder:(NSCoder*)coder {
	if (self = [super initWithCoder:coder]) {

    }
	return self;
}

// Draw the title on a transparent background
- (void)drawRect:(CGRect)rect {
    // The offsets come from our view controllers notification deviceMoved:
    CGFloat xAdjustment = 11 * self.offsets.x;
    CGFloat yAdjustment = 11 * self.offsets.y;
    
    //NSLog(@"TV offset x %f y %f", xAdjustment, yAdjustment);
    
    /// General declarations
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    /// Color declarations
    UIColor *puttaYellow = [UIColor colorWithRed: 0.98 green: 0.741 blue: 0.225 alpha: 1];
    UIColor *shadowColor = [UIColor colorWithRed: 0.341 green: 0.023 blue: 0.01 alpha: 0.64];
    
    /// Shadow declarations
    UIColor *shadow = shadowColor;
    CGSize shadowOffset = CGSizeMake(3.3 - xAdjustment, 3.3 - yAdjustment);
    CGFloat shadowBlurRadius = 6;
    
    //// Tokidoki kerned drawing with shadow
    UIBezierPath* tokidokiPath = [UIBezierPath bezierPath];
    [tokidokiPath moveToPoint: CGPointMake(57.42, 16.22)];
    [tokidokiPath addCurveToPoint: CGPointMake(58.44, 20.45) controlPoint1: CGPointMake(57.74, 17.12) controlPoint2: CGPointMake(57.8, 17.5)];
    [tokidokiPath addCurveToPoint: CGPointMake(62.22, 37.28) controlPoint1: CGPointMake(60.36, 30.18) controlPoint2: CGPointMake(60.68, 31.71)];
    [tokidokiPath addCurveToPoint: CGPointMake(54.22, 42.14) controlPoint1: CGPointMake(58.32, 39.26) controlPoint2: CGPointMake(56.46, 40.35)];
    [tokidokiPath addCurveToPoint: CGPointMake(47.63, 55.33) controlPoint1: CGPointMake(50.06, 45.47) controlPoint2: CGPointMake(47.63, 50.4)];
    [tokidokiPath addCurveToPoint: CGPointMake(53.52, 67.36) controlPoint1: CGPointMake(47.63, 60.38) controlPoint2: CGPointMake(49.87, 64.99)];
    [tokidokiPath addCurveToPoint: CGPointMake(73.42, 71.39) controlPoint1: CGPointMake(57.74, 70.05) controlPoint2: CGPointMake(64.2, 71.39)];
    [tokidokiPath addCurveToPoint: CGPointMake(89.55, 70.3) controlPoint1: CGPointMake(78.09, 71.39) controlPoint2: CGPointMake(82.44, 71.07)];
    [tokidokiPath addCurveToPoint: CGPointMake(95.12, 69.79) controlPoint1: CGPointMake(92.81, 69.92) controlPoint2: CGPointMake(93.52, 69.86)];
    [tokidokiPath addLineToPoint: CGPointMake(94.28, 57.63)];
    [tokidokiPath addCurveToPoint: CGPointMake(90.89, 58.59) controlPoint1: CGPointMake(92.49, 58.21) controlPoint2: CGPointMake(91.85, 58.4)];
    [tokidokiPath addCurveToPoint: CGPointMake(72.14, 60.64) controlPoint1: CGPointMake(85.07, 59.87) controlPoint2: CGPointMake(77.96, 60.64)];
    [tokidokiPath addCurveToPoint: CGPointMake(59.4, 55.01) controlPoint1: CGPointMake(63.24, 60.64) controlPoint2: CGPointMake(59.4, 58.91)];
    [tokidokiPath addCurveToPoint: CGPointMake(71.82, 44.96) controlPoint1: CGPointMake(59.4, 51.23) controlPoint2: CGPointMake(63.63, 47.84)];
    [tokidokiPath addCurveToPoint: CGPointMake(94.73, 39.01) controlPoint1: CGPointMake(79.44, 42.34) controlPoint2: CGPointMake(88.4, 39.97)];
    [tokidokiPath addLineToPoint: CGPointMake(91.08, 27.62)];
    [tokidokiPath addCurveToPoint: CGPointMake(88.46, 28.58) controlPoint1: CGPointMake(90.19, 28.06) controlPoint2: CGPointMake(89.93, 28.13)];
    [tokidokiPath addCurveToPoint: CGPointMake(80.08, 31.07) controlPoint1: CGPointMake(86.16, 29.28) controlPoint2: CGPointMake(86.16, 29.28)];
    [tokidokiPath addCurveToPoint: CGPointMake(72.72, 33.44) controlPoint1: CGPointMake(77.45, 31.78) controlPoint2: CGPointMake(75.6, 32.42)];
    [tokidokiPath addCurveToPoint: CGPointMake(69.07, 14.5) controlPoint1: CGPointMake(70.8, 26.4) controlPoint2: CGPointMake(69.32, 18.72)];
    [tokidokiPath addLineToPoint: CGPointMake(57.42, 16.22)];
    [tokidokiPath closePath];
    [tokidokiPath moveToPoint: CGPointMake(108.01, 31.71)];
    [tokidokiPath addCurveToPoint: CGPointMake(112.81, 31.58) controlPoint1: CGPointMake(109.48, 31.65) controlPoint2: CGPointMake(109.93, 31.65)];
    [tokidokiPath addCurveToPoint: CGPointMake(129.52, 30.88) controlPoint1: CGPointMake(120.94, 31.58) controlPoint2: CGPointMake(123.88, 31.46)];
    [tokidokiPath addCurveToPoint: CGPointMake(130.99, 34.27) controlPoint1: CGPointMake(130.28, 32.61) controlPoint2: CGPointMake(130.8, 33.76)];
    [tokidokiPath addCurveToPoint: CGPointMake(113.52, 35.17) controlPoint1: CGPointMake(125.8, 34.85) controlPoint2: CGPointMake(119.66, 35.17)];
    [tokidokiPath addCurveToPoint: CGPointMake(106.92, 34.91) controlPoint1: CGPointMake(110, 35.17) controlPoint2: CGPointMake(108.78, 35.1)];
    [tokidokiPath addLineToPoint: CGPointMake(107.37, 44.38)];
    [tokidokiPath addCurveToPoint: CGPointMake(112.94, 44.06) controlPoint1: CGPointMake(108.91, 44.19) controlPoint2: CGPointMake(109.1, 44.19)];
    [tokidokiPath addCurveToPoint: CGPointMake(134.96, 42.66) controlPoint1: CGPointMake(122.16, 43.81) controlPoint2: CGPointMake(129.52, 43.36)];
    [tokidokiPath addCurveToPoint: CGPointMake(137.9, 47.2) controlPoint1: CGPointMake(136.24, 44.7) controlPoint2: CGPointMake(137.2, 46.24)];
    [tokidokiPath addCurveToPoint: CGPointMake(129.07, 46.43) controlPoint1: CGPointMake(135.02, 46.62) controlPoint2: CGPointMake(132.46, 46.43)];
    [tokidokiPath addCurveToPoint: CGPointMake(115.37, 48.8) controlPoint1: CGPointMake(123.5, 46.43) controlPoint2: CGPointMake(119.15, 47.2)];
    [tokidokiPath addCurveToPoint: CGPointMake(107.76, 59.36) controlPoint1: CGPointMake(110.7, 50.78) controlPoint2: CGPointMake(107.76, 54.88)];
    [tokidokiPath addCurveToPoint: CGPointMake(110.12, 66.4) controlPoint1: CGPointMake(107.76, 61.86) controlPoint2: CGPointMake(108.65, 64.48)];
    [tokidokiPath addCurveToPoint: CGPointMake(129.52, 72.48) controlPoint1: CGPointMake(113.26, 70.43) controlPoint2: CGPointMake(119.79, 72.48)];
    [tokidokiPath addCurveToPoint: CGPointMake(147.44, 70.5) controlPoint1: CGPointMake(135.47, 72.48) controlPoint2: CGPointMake(141.36, 71.84)];
    [tokidokiPath addCurveToPoint: CGPointMake(151.92, 69.6) controlPoint1: CGPointMake(150.57, 69.79) controlPoint2: CGPointMake(150.57, 69.79)];
    [tokidokiPath addLineToPoint: CGPointMake(150.44, 58.78)];
    [tokidokiPath addCurveToPoint: CGPointMake(130.09, 62.75) controlPoint1: CGPointMake(145.32, 61.22) controlPoint2: CGPointMake(137.45, 62.75)];
    [tokidokiPath addCurveToPoint: CGPointMake(119.98, 59.23) controlPoint1: CGPointMake(123.31, 62.75) controlPoint2: CGPointMake(119.98, 61.6)];
    [tokidokiPath addCurveToPoint: CGPointMake(130.99, 55.07) controlPoint1: CGPointMake(119.98, 56.54) controlPoint2: CGPointMake(123.88, 55.07)];
    [tokidokiPath addCurveToPoint: CGPointMake(144.43, 57.89) controlPoint1: CGPointMake(136.56, 55.07) controlPoint2: CGPointMake(140.65, 55.9)];
    [tokidokiPath addLineToPoint: CGPointMake(153.84, 53.02)];
    [tokidokiPath addCurveToPoint: CGPointMake(145.64, 41.25) controlPoint1: CGPointMake(150.06, 48.42) controlPoint2: CGPointMake(148.27, 45.86)];
    [tokidokiPath addCurveToPoint: CGPointMake(149.48, 40.54) controlPoint1: CGPointMake(146.48, 41.06) controlPoint2: CGPointMake(149.42, 40.54)];
    [tokidokiPath addCurveToPoint: CGPointMake(157.36, 39.01) controlPoint1: CGPointMake(155.88, 39.2) controlPoint2: CGPointMake(155.88, 39.2)];
    [tokidokiPath addLineToPoint: CGPointMake(156.4, 29.6)];
    [tokidokiPath addCurveToPoint: CGPointMake(141.48, 32.99) controlPoint1: CGPointMake(153.45, 30.69) controlPoint2: CGPointMake(150.38, 31.39)];
    [tokidokiPath addCurveToPoint: CGPointMake(140.01, 29.66) controlPoint1: CGPointMake(141.23, 32.54) controlPoint2: CGPointMake(140.52, 30.88)];
    [tokidokiPath addCurveToPoint: CGPointMake(150.19, 27.81) controlPoint1: CGPointMake(146.41, 28.64) controlPoint2: CGPointMake(146.48, 28.58)];
    [tokidokiPath addCurveToPoint: CGPointMake(154.92, 26.85) controlPoint1: CGPointMake(153.71, 27.1) controlPoint2: CGPointMake(153.71, 27.1)];
    [tokidokiPath addLineToPoint: CGPointMake(154.03, 17.5)];
    [tokidokiPath addCurveToPoint: CGPointMake(136.68, 21.09) controlPoint1: CGPointMake(150.32, 18.72) controlPoint2: CGPointMake(142.83, 20.26)];
    [tokidokiPath addCurveToPoint: CGPointMake(134.7, 14.43) controlPoint1: CGPointMake(135.47, 17.95) controlPoint2: CGPointMake(135.02, 16.48)];
    [tokidokiPath addLineToPoint: CGPointMake(123.5, 15.78)];
    [tokidokiPath addCurveToPoint: CGPointMake(126.19, 22.18) controlPoint1: CGPointMake(124.08, 16.93) controlPoint2: CGPointMake(124.84, 18.66)];
    [tokidokiPath addCurveToPoint: CGPointMake(114.73, 22.62) controlPoint1: CGPointMake(123.31, 22.43) controlPoint2: CGPointMake(118.38, 22.62)];
    [tokidokiPath addCurveToPoint: CGPointMake(107.44, 22.3) controlPoint1: CGPointMake(111.79, 22.62) controlPoint2: CGPointMake(109.68, 22.56)];
    [tokidokiPath addLineToPoint: CGPointMake(108.01, 31.71)];
    [tokidokiPath closePath];
    [tokidokiPath moveToPoint: CGPointMake(196.69, 18.27)];
    [tokidokiPath addCurveToPoint: CGPointMake(201.49, 27.68) controlPoint1: CGPointMake(198.93, 21.6) controlPoint2: CGPointMake(200.21, 24.16)];
    [tokidokiPath addLineToPoint: CGPointMake(208.15, 25.18)];
    [tokidokiPath addCurveToPoint: CGPointMake(203.16, 16.16) controlPoint1: CGPointMake(206.68, 21.47) controlPoint2: CGPointMake(205.46, 19.3)];
    [tokidokiPath addLineToPoint: CGPointMake(196.69, 18.27)];
    [tokidokiPath closePath];
    [tokidokiPath moveToPoint: CGPointMake(205.01, 15.52)];
    [tokidokiPath addCurveToPoint: CGPointMake(209.94, 24.67) controlPoint1: CGPointMake(207.7, 19.49) controlPoint2: CGPointMake(208.66, 21.22)];
    [tokidokiPath addLineToPoint: CGPointMake(216.28, 22.11)];
    [tokidokiPath addCurveToPoint: CGPointMake(211.22, 13.22) controlPoint1: CGPointMake(214.87, 18.66) controlPoint2: CGPointMake(213.46, 16.16)];
    [tokidokiPath addLineToPoint: CGPointMake(205.01, 15.52)];
    [tokidokiPath closePath];
    [tokidokiPath moveToPoint: CGPointMake(174.16, 16.54)];
    [tokidokiPath addCurveToPoint: CGPointMake(175.19, 20.77) controlPoint1: CGPointMake(174.48, 17.44) controlPoint2: CGPointMake(174.55, 17.76)];
    [tokidokiPath addCurveToPoint: CGPointMake(178.96, 37.6) controlPoint1: CGPointMake(177.11, 30.5) controlPoint2: CGPointMake(177.43, 32.03)];
    [tokidokiPath addCurveToPoint: CGPointMake(170.96, 42.46) controlPoint1: CGPointMake(175.06, 39.52) controlPoint2: CGPointMake(173.2, 40.67)];
    [tokidokiPath addCurveToPoint: CGPointMake(164.37, 55.65) controlPoint1: CGPointMake(166.8, 45.79) controlPoint2: CGPointMake(164.37, 50.66)];
    [tokidokiPath addCurveToPoint: CGPointMake(170.26, 67.68) controlPoint1: CGPointMake(164.37, 60.7) controlPoint2: CGPointMake(166.61, 65.31)];
    [tokidokiPath addCurveToPoint: CGPointMake(190.16, 71.71) controlPoint1: CGPointMake(174.48, 70.37) controlPoint2: CGPointMake(180.95, 71.71)];
    [tokidokiPath addCurveToPoint: CGPointMake(206.29, 70.62) controlPoint1: CGPointMake(194.84, 71.71) controlPoint2: CGPointMake(199.19, 71.39)];
    [tokidokiPath addCurveToPoint: CGPointMake(211.86, 70.11) controlPoint1: CGPointMake(209.56, 70.24) controlPoint2: CGPointMake(210.26, 70.18)];
    [tokidokiPath addLineToPoint: CGPointMake(211.03, 57.95)];
    [tokidokiPath addCurveToPoint: CGPointMake(207.64, 58.91) controlPoint1: CGPointMake(209.24, 58.53) controlPoint2: CGPointMake(208.6, 58.72)];
    [tokidokiPath addCurveToPoint: CGPointMake(188.88, 60.96) controlPoint1: CGPointMake(201.81, 60.19) controlPoint2: CGPointMake(194.71, 60.96)];
    [tokidokiPath addCurveToPoint: CGPointMake(176.15, 55.33) controlPoint1: CGPointMake(179.99, 60.96) controlPoint2: CGPointMake(176.15, 59.23)];
    [tokidokiPath addCurveToPoint: CGPointMake(188.56, 45.28) controlPoint1: CGPointMake(176.15, 51.55) controlPoint2: CGPointMake(180.37, 48.16)];
    [tokidokiPath addCurveToPoint: CGPointMake(211.48, 39.33) controlPoint1: CGPointMake(196.18, 42.59) controlPoint2: CGPointMake(205.14, 40.29)];
    [tokidokiPath addLineToPoint: CGPointMake(207.83, 27.94)];
    [tokidokiPath addCurveToPoint: CGPointMake(205.2, 28.83) controlPoint1: CGPointMake(206.93, 28.32) controlPoint2: CGPointMake(206.68, 28.45)];
    [tokidokiPath addCurveToPoint: CGPointMake(196.82, 31.33) controlPoint1: CGPointMake(202.9, 29.54) controlPoint2: CGPointMake(202.9, 29.54)];
    [tokidokiPath addCurveToPoint: CGPointMake(189.46, 33.7) controlPoint1: CGPointMake(194.2, 32.1) controlPoint2: CGPointMake(192.34, 32.67)];
    [tokidokiPath addCurveToPoint: CGPointMake(185.81, 14.75) controlPoint1: CGPointMake(187.54, 26.72) controlPoint2: CGPointMake(186.07, 18.98)];
    [tokidokiPath addLineToPoint: CGPointMake(174.16, 16.54)];
    [tokidokiPath closePath];
    [tokidokiPath moveToPoint: CGPointMake(225.01, 31.71)];
    [tokidokiPath addCurveToPoint: CGPointMake(229.81, 31.58) controlPoint1: CGPointMake(226.48, 31.65) controlPoint2: CGPointMake(226.93, 31.65)];
    [tokidokiPath addCurveToPoint: CGPointMake(246.52, 30.88) controlPoint1: CGPointMake(237.94, 31.58) controlPoint2: CGPointMake(240.88, 31.46)];
    [tokidokiPath addCurveToPoint: CGPointMake(247.99, 34.27) controlPoint1: CGPointMake(247.28, 32.61) controlPoint2: CGPointMake(247.8, 33.76)];
    [tokidokiPath addCurveToPoint: CGPointMake(230.52, 35.17) controlPoint1: CGPointMake(242.8, 34.85) controlPoint2: CGPointMake(236.66, 35.17)];
    [tokidokiPath addCurveToPoint: CGPointMake(223.92, 34.91) controlPoint1: CGPointMake(227, 35.17) controlPoint2: CGPointMake(225.78, 35.1)];
    [tokidokiPath addLineToPoint: CGPointMake(224.37, 44.38)];
    [tokidokiPath addCurveToPoint: CGPointMake(229.94, 44.06) controlPoint1: CGPointMake(225.91, 44.19) controlPoint2: CGPointMake(226.1, 44.19)];
    [tokidokiPath addCurveToPoint: CGPointMake(251.96, 42.66) controlPoint1: CGPointMake(239.16, 43.81) controlPoint2: CGPointMake(246.52, 43.36)];
    [tokidokiPath addCurveToPoint: CGPointMake(254.9, 47.2) controlPoint1: CGPointMake(253.24, 44.7) controlPoint2: CGPointMake(254.2, 46.24)];
    [tokidokiPath addCurveToPoint: CGPointMake(246.07, 46.43) controlPoint1: CGPointMake(252.02, 46.62) controlPoint2: CGPointMake(249.46, 46.43)];
    [tokidokiPath addCurveToPoint: CGPointMake(232.37, 48.8) controlPoint1: CGPointMake(240.5, 46.43) controlPoint2: CGPointMake(236.15, 47.2)];
    [tokidokiPath addCurveToPoint: CGPointMake(224.76, 59.36) controlPoint1: CGPointMake(227.7, 50.78) controlPoint2: CGPointMake(224.76, 54.88)];
    [tokidokiPath addCurveToPoint: CGPointMake(227.12, 66.4) controlPoint1: CGPointMake(224.76, 61.86) controlPoint2: CGPointMake(225.65, 64.48)];
    [tokidokiPath addCurveToPoint: CGPointMake(246.52, 72.48) controlPoint1: CGPointMake(230.26, 70.43) controlPoint2: CGPointMake(236.79, 72.48)];
    [tokidokiPath addCurveToPoint: CGPointMake(264.44, 70.5) controlPoint1: CGPointMake(252.47, 72.48) controlPoint2: CGPointMake(258.36, 71.84)];
    [tokidokiPath addCurveToPoint: CGPointMake(268.92, 69.6) controlPoint1: CGPointMake(267.57, 69.79) controlPoint2: CGPointMake(267.57, 69.79)];
    [tokidokiPath addLineToPoint: CGPointMake(267.44, 58.78)];
    [tokidokiPath addCurveToPoint: CGPointMake(247.09, 62.75) controlPoint1: CGPointMake(262.32, 61.22) controlPoint2: CGPointMake(254.45, 62.75)];
    [tokidokiPath addCurveToPoint: CGPointMake(236.98, 59.23) controlPoint1: CGPointMake(240.31, 62.75) controlPoint2: CGPointMake(236.98, 61.6)];
    [tokidokiPath addCurveToPoint: CGPointMake(247.99, 55.07) controlPoint1: CGPointMake(236.98, 56.54) controlPoint2: CGPointMake(240.88, 55.07)];
    [tokidokiPath addCurveToPoint: CGPointMake(261.43, 57.89) controlPoint1: CGPointMake(253.56, 55.07) controlPoint2: CGPointMake(257.65, 55.9)];
    [tokidokiPath addLineToPoint: CGPointMake(270.84, 53.02)];
    [tokidokiPath addCurveToPoint: CGPointMake(262.64, 41.25) controlPoint1: CGPointMake(267.06, 48.42) controlPoint2: CGPointMake(265.27, 45.86)];
    [tokidokiPath addCurveToPoint: CGPointMake(266.48, 40.54) controlPoint1: CGPointMake(263.48, 41.06) controlPoint2: CGPointMake(266.42, 40.54)];
    [tokidokiPath addCurveToPoint: CGPointMake(274.36, 39.01) controlPoint1: CGPointMake(272.88, 39.2) controlPoint2: CGPointMake(272.88, 39.2)];
    [tokidokiPath addLineToPoint: CGPointMake(273.4, 29.6)];
    [tokidokiPath addCurveToPoint: CGPointMake(258.48, 32.99) controlPoint1: CGPointMake(270.45, 30.69) controlPoint2: CGPointMake(267.38, 31.39)];
    [tokidokiPath addCurveToPoint: CGPointMake(257.01, 29.66) controlPoint1: CGPointMake(258.23, 32.54) controlPoint2: CGPointMake(257.52, 30.88)];
    [tokidokiPath addCurveToPoint: CGPointMake(267.19, 27.81) controlPoint1: CGPointMake(263.41, 28.64) controlPoint2: CGPointMake(263.48, 28.58)];
    [tokidokiPath addCurveToPoint: CGPointMake(271.92, 26.85) controlPoint1: CGPointMake(270.71, 27.1) controlPoint2: CGPointMake(270.71, 27.1)];
    [tokidokiPath addLineToPoint: CGPointMake(271.03, 17.5)];
    [tokidokiPath addCurveToPoint: CGPointMake(253.68, 21.09) controlPoint1: CGPointMake(267.32, 18.72) controlPoint2: CGPointMake(259.83, 20.26)];
    [tokidokiPath addCurveToPoint: CGPointMake(251.7, 14.43) controlPoint1: CGPointMake(252.47, 17.95) controlPoint2: CGPointMake(252.02, 16.48)];
    [tokidokiPath addLineToPoint: CGPointMake(240.5, 15.78)];
    [tokidokiPath addCurveToPoint: CGPointMake(243.19, 22.18) controlPoint1: CGPointMake(241.08, 16.93) controlPoint2: CGPointMake(241.84, 18.66)];
    [tokidokiPath addCurveToPoint: CGPointMake(231.73, 22.62) controlPoint1: CGPointMake(240.31, 22.43) controlPoint2: CGPointMake(235.38, 22.62)];
    [tokidokiPath addCurveToPoint: CGPointMake(224.44, 22.3) controlPoint1: CGPointMake(228.79, 22.62) controlPoint2: CGPointMake(226.68, 22.56)];
    [tokidokiPath addLineToPoint: CGPointMake(225.01, 31.71)];
    [tokidokiPath closePath];
    
    CGContextSaveGState(context);
    CGContextSetShadowWithColor(context, shadowOffset, shadowBlurRadius, shadow.CGColor);
    [puttaYellow setFill];
    [tokidokiPath fill];
    CGContextRestoreGState(context);
}

@end
